//
//  Action.h
//  Skip Checker
//
//  Created by Sven on 16.10.06 for SkipChecker.
//  Copyright 2006 earthlingsoft.
//	http://earthlingsoft.net/Skip%20Checker  earthlingsoft@earthlingsoft.net
//
//	Feel free to use this code at your risk and for your own amusement. 
//	If you find it helpful and can use it for yourself, don't forget to give credit.
//	If you spot problems with the code, please let us know.

#import <Cocoa/Cocoa.h>

#define ACTIONTEXT @"actionText"
#define ACTION @"action"
#define TRIGGERLEVEL @"triggerLevel"
#define LASTTRIGGERED @"lastTriggered"
#define MODE @"mode"
#define COLOUR @"colour"

typedef enum {
	triggerWhenGoingAbove = 1,
	triggerWhenGoingBelow = 2
} TriggerMode;


/*
 Class to incorporate an action in Skip Checker. 
 It stores 
	* the text designating an action, 
	* the script or sound that comprises the action
 It handles executing the action. 
 
 A value transformer to provide colours depending on the action's status is also provided.
*/

@interface Action : NSObject {
	NSString *actionText;
	id action;
	NSNumber *triggerLevel;
	NSTimeInterval lastTriggered;
	TriggerMode mode;
	NSColor * colour;
}

+ (id) actionWithAction:(id) theAction triggerLevel:(NSNumber *) theLevel mode:(NSNumber*) theMode;
- (BOOL) runForLevel:(NSNumber *) theLevel withDelta:(NSNumber *) delta;
- (BOOL) runAction;
@end


// The value transformer didn't work well in practice, so a less sophisticated working solution of storing the colour int he colour object and binding that to the display colour is used instead.
/*
@interface actionToColourTransformer : NSValueTransformer {
}
@end
*/