// Derived for Skip Checker http://earthlingsoft.net/Skip%20Checker
// from the Sinewave demo application by James MacCartney
// rather use the clean original than this if you are looking for a starting point for your own programming

// Sinewave - a very simple Cocoa CoreAudio app
// by James McCartney  james@audiosynth.com  http://www.audiosynth.com
//
// Sinewave - this class implements a sine oscillator with dezippered control of frequency, pan and amplitude
//

#import <Cocoa/Cocoa.h>
#include <CoreAudio/AudioHardware.h>

#define FREQ1 @"freq1"
#define FREQ2 @"freq2"
#define SOUNDPLAYING @"soundPlaying"
#define MIXINGBIAS @"mixingBias"
#define WAVEVOLUME @"volume"

@interface Sinewave : NSObject
{
	double freq1, pan1, amp1;		// controls
	double freq2, pan2, amp2;		// controls
    double freqz1, panz1, ampz1;	// for dezipper filter
    double freqz2, panz2, ampz2;	// for dezipper filter
    double phase1, phase2;			// oscillator phase in radians
	double mixingBias;				// a value between 0 and 1 giving the way freq1 and freq2 are mixed
	
	Boolean	initialized;			// successful init?
	Boolean	soundPlaying;			// playing now?
	AudioDeviceID device;			// the default device
	UInt32	deviceBufferSize;		// bufferSize returned by kAudioDevicePropertyBufferSize
	AudioStreamBasicDescription	deviceFormat;	// info about the default device
}

- (void)setup;
- (BOOL)start;
- (BOOL)stop;

- (void)setAmpVal:(double)val;
// - (void)setFreqVal:(double)val;
- (void)setPanVal:(double)val;

- (double) frequency1;
- (void) setFrequency1:(double) val;
- (double) frequency2;
- (void) setFrequency2:(double) val;
- (void) setVolume: (NSNumber *) newVolume;
- (NSNumber*) volume;
	
/*
- (double) volume1;
- (void) setVolume1:(double) val;
- (double) volume2;
- (void) setVolume2:(double) val;
*/

@end
