//
//  SkipChecker.h
//  Skip Checker
//
//  Created by Sven on 14.09.06 for SkipChecker.
//  Copyright 2006 earthlingsoft.
//	http://earthlingsoft.net/Skip%20Checker  earthlingsoft@earthlingsoft.net
//
//	Feel free to use this code at your risk and for your own amusement. 
//	If you find it helpful and can use it for yourself, don't forget to give credit.
//	If you spot problems with the code, please let us know.

#import <Cocoa/Cocoa.h>
#import "CalibrationController.h"

#define HFSCREATORCODE 'esSK'
#define HFSTYPECODE 'esSK'


// keys for magic coordinate dictionary
#define xValue @"x"
#define yValue @"y"
#define zValue @"z"

// keys for limits
#define XLIMIT @"xLimit"
#define YLIMIT @"yLimit"
#define ZLIMIT @"zLimit"

// calibration
#define XCALIBRATION @"xCalibration"
#define YCALIBRATION @"yCalibration"
#define ZCALIBRATION @"zCalibration"

#define LIMITDELTA 25

#define SMSValuesChangedNotification @"SMSChanged"

// keys for  current levels
#define CURRENTXLEVEL @"levelX"
#define CURRENTYLEVEL @"levelY"
#define CURRENTZLEVEL @"levelZ"

// keys for current settings
#define CURRENTTAB @"currentTab"
#define REPETITIONINTERVAL @"repetitionInterval"
#define TIMEBETWEENSKIPS @"timebetweenskips"
#define RUNNING @"running"
#define CONTENTHEIGHT @"contentHeight"
#define CONTENTWIDTH @"contentWidth"
#define HIDENUMBERS @"hideNumbers"

// workspace
#define WORKSPACE [NSWorkspace sharedWorkspace]
#define DEFAULTS [NSUserDefaults standardUserDefaults]
#define CALIBRATIONCONTROLLER @"calibrationController"


/* 
The SkipChecker class is the application delegate for the application.
 Apart from setting up basics for the application like value transformers, it sets up and handles the periodic reading of motion sensor data which the instances of the document class grab via KVO. Likewise it runs the calibration window.
*/

@interface SkipChecker : NSObject {
	NSNumber *levelX;
	NSNumber *levelY;
	NSNumber *levelZ;
		
	int xCalibration;
	int yCalibration;
	int zCalibration;
	
	IBOutlet CalibrationController *calibrationController;
	
	int SMSType;

	NSTimer * myTimer;
}

- (BOOL) doMagic;
- (IBAction) showHelp:(id) sender;
- (IBAction) toggleShowNumbers:(id) sender;

- (NSString*) myVersionString;
@end
