//
//  esFrequencyMusicTransformer.h
//  Skip Checker
//
//
//  Created by Sven on 17.10.06 for SkipChecker.
//  Copyright 2006 earthlingsoft.
//	http://earthlingsoft.net/Skip%20Checker  earthlingsoft@earthlingsoft.net
//
//	Feel free to use this code at your risk and for your own amusement. 
//	If you find it helpful and can use it for yourself, don't forget to give credit.
//	If you spot problems with the code, please let us know.


#import <Cocoa/Cocoa.h>


/*
	A very specific transformer which takes a base 2 logarithm.
	As going up one octave means you are doubling the frequency, this is useful for displaying a scale where all octaves have the same length when the actual values stored are the corresponding frequencies.
	Thus we have output = log2(input/ 27.5) and the associated reverse transformation.
	where 27.5Hz is the frequency of A0
*/
@interface esFrequencyMusicTransformer : NSValueTransformer {
}
@end

/*
	A transformer converting a frequency into the name of the corresponding note.
	This is a one-way transformer. 
	Currently it only displays the note's name and doesn't display the octave it is in. (Adding that will be simple though). It will also match frequencies close to the correct one (up to 10% the way to the next demi-note)
	E.g. you get 440 -> A
	For best effects, such as Unicode characters for the sharps and flats and the necessary localisation of note names, this requires the NoteNames.strings file.
	This transformer does what I needed, but it could be extended in many ways.
*/ 
@interface esFrequencyNoteTransformer : NSValueTransformer {
}
@end
