//
//  esNegativeTransformer.m
//  Skip Checker
//
//  Created by Sven for Skip Checker on 19.09.06.
//	http://earthlingsoft.net/Skip%20Checker  earthlingsoft@earthlingsoft.net

// These classes a pretty much a direct rip-off of Apple's example code for the topic. So better use the original if you're interested.


#import "esNegativeTransformer.h"


@implementation esNegativeTransformer

+ (Class)transformedValueClass;
{
    return [NSNumber class];
}

+ (BOOL)allowsReverseTransformation;
{
    return YES;   
}


- (id)transformedValue:(id)value;
{
    float originalValue;
    float negativeValue;
    
    if (value == nil) return nil;
    
    // Attempt to get a reasonable value from the value object. 
    if ([value respondsToSelector: @selector(floatValue)]) {
		// handles NSString and NSNumber
        originalValue = [value floatValue]; 
    } else {
        [NSException raise: NSInternalInconsistencyException format: @"Value (%@) does not respond to -floatValue.", [value class]];
    }
	
	negativeValue = -originalValue;
	
    return [NSNumber numberWithFloat: negativeValue];
}


- (id)reverseTransformedValue:(id)value;
{
	return [self transformedValue:value];
}


@end





@implementation esTimesHundredTransformer

+ (Class)transformedValueClass;
{
    return [NSNumber class];
}

+ (BOOL)allowsReverseTransformation;
{
    return YES;   
}


- (id)transformedValue:(id)value;
{
    float originalValue;
    float newValue;
    
    if (value == nil) return nil;
    
    // Attempt to get a reasonable value from the value object. 
    if ([value respondsToSelector: @selector(floatValue)]) {
		// handles NSString and NSNumber
        originalValue = [value floatValue]; 
    } else {
        [NSException raise: NSInternalInconsistencyException format: @"Value (%@) does not respond to -floatValue.", [value class]];
    }
	
	newValue = 100.0 * originalValue;
	
    return [NSNumber numberWithFloat: newValue];
}


- (id)reverseTransformedValue:(id)value;
{
    float originalValue;
    float newValue;
    
    if (value == nil) return nil;
    
    // Attempt to get a reasonable value from the value object. 
    if ([value respondsToSelector: @selector(floatValue)]) {
		// handles NSString and NSNumber
        originalValue = [value floatValue]; 
    } else {
        [NSException raise: NSInternalInconsistencyException format: @"Value (%@) does not respond to -floatValue.", [value class]];
    }
	
	newValue = originalValue / 100.0;
	
    return [NSNumber numberWithFloat: newValue];
}


@end

